Bug 1028623 - Measurement data points can be supplied to condition processing in different order than generated on agent
Measurement data points can be supplied to condition processing in different ...
Status: CLOSED CURRENTRELEASE
Product: JBoss Operations Network
Classification: JBoss
Component: Core Server, Monitoring - Alerts (Show other bugs)
JON 3.2
Unspecified Unspecified
unspecified Severity high
: ER02
: JON 3.3.0
Assigned To: John Sanda
Mike Foley
:
Depends On: 1028624
Blocks:
  Show dependency treegraph
 
Reported: 2013-11-08 16:43 EST by Lukas Krejci
Modified: 2014-12-11 09:00 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 1028624 (view as bug list)
Environment:
Last Closed: 2014-12-11 09:00:17 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Lukas Krejci 2013-11-08 16:43:37 EST
Description of problem:
When measurement data comes in to the server, the alert condition processing relies on the order to be strictly the same as generated on the agent side. I.e. no datapoint should be processed before another that was detected prior to it.

The persistence to the Cassandra storage node is asynchronous and done on datapoint-by-datapoint basis. This means that the datapoints can be persisted in different order than the original order.

When supplying the data to alert condition processing, we use the order of datapoints in which they were persisted, not the one they were created on the agent.

This can lead to subtle bugs in alerting like false positive or negative dampening events.

Version-Release number of selected component (if applicable):
JON 3.2.0.ER4

How reproducible:
hardly, can be best seen in debugger

Steps to Reproduce:
1. Have a server, agent and some enabled metric schedules for some inventoried resources
2. Once a measurement report comes in, check the order of elements in the input parameter of the MeasurementDataManagerBean#addNumericData() method.
3. Check the order of elements of the data passed to the condition processing in the onFinish() callback inside addNumericData()

Actual results:
The order sometimes differ, depending on the order cassandra cluster happened to store the events

Expected results:
The order of elements passed to the condition processing should be the same as the one coming from agents.

Additional info:
Comment 1 Jay Shaughnessy 2014-09-04 22:03:36 EDT
The upstream fix was committed a while back.  Moving to ON_QA but this code-level change is not easily testable.  Suggest to just set closed/currentrelease or something like that.
Comment 2 Lukas Krejci 2014-09-10 10:25:46 EDT
This is almost impossible to QE. Verified by code inspection.

Note You need to log in before you can comment on or make changes to this bug.